Index: codes/icosagcm/trunk/src/advect_tracer.f90
===================================================================
--- codes/icosagcm/trunk/src/advect_tracer.f90	(revision 294)
+++ codes/icosagcm/trunk/src/advect_tracer.f90	(revision 295)
@@ -26,4 +26,5 @@
   SUBROUTINE init_advect_tracer
     USE advect_mod
+    USE omp_para
     REAL(rstd),POINTER :: tangent(:,:)
     REAL(rstd),POINTER :: normal(:,:)
@@ -48,5 +49,5 @@
        tangent=f_tangent(ind)
        sqrt_leng=f_sqrt_leng(ind)
-       CALL init_advect(normal,tangent,sqrt_leng)
+       IF (is_omp_level_master) CALL init_advect(normal,tangent,sqrt_leng)
     END DO
 
@@ -238,5 +239,5 @@
 
 !--> flush dzqw, adzqw
-!!$OMP BARRIER
+!$OMP BARRIER
 
     ! minmod-limited slope of q
@@ -258,5 +259,5 @@
 
     ! 0 slope in top and bottom layers
-    IF (omp_first) THEN
+    IF (is_omp_first_level) THEN
       DO ij=ijb,ije
            dzq(ij,1)=0.
@@ -264,5 +265,5 @@
     ENDIF
       
-    IF (omp_last) THEN
+    IF (is_omp_last_level) THEN
       DO ij=ijb,ije
           dzq(ij,llm)=0.
@@ -271,5 +272,5 @@
 
 !---> flush dzq
-!!$OMP BARRIER  
+!$OMP BARRIER  
 
     ! sigw = fraction of mass that leaves level l/l+1
@@ -290,5 +291,5 @@
     END DO
     ! wq = 0 at top and bottom
-    IF (omp_first) THEN
+    IF (is_omp_first_level) THEN
        DO ij=ijb,ije
             wq(ij,1)=0.
@@ -296,5 +297,5 @@
     ENDIF
     
-    IF (omp_last) THEN
+    IF (is_omp_last_level) THEN
       DO ij=ijb,ije
             wq(ij,llm+1)=0.
@@ -303,5 +304,5 @@
 
 ! --> flush wq
-!!$OMP BARRIER
+!$OMP BARRIER
 
 
Index: codes/icosagcm/trunk/src/caldyn_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/caldyn_gcm.f90	(revision 294)
+++ codes/icosagcm/trunk/src/caldyn_gcm.f90	(revision 295)
@@ -33,4 +33,5 @@
     USE exner_mod
     USE mpipara
+    USE omp_para
     IMPLICIT NONE
     CHARACTER(len=255) :: def
@@ -50,5 +51,5 @@
        STOP
     END SELECT
-    IF (is_mpi_root) PRINT *, 'caldyn_conserv=',def
+    IF (is_master) PRINT *, 'caldyn_conserv=',def
 
     CALL allocate_caldyn
@@ -72,5 +73,5 @@
     CALL allocate_field(f_qv,field_z,type_real,llm) 
   
-    CALL allocate_field(f_buf_i,   field_t,type_real,llm)
+    CALL allocate_field(f_buf_i,   field_t,type_real,llm,name="buffer_i")
     CALL allocate_field(f_buf_p,   field_t,type_real,llm+1) 
     CALL allocate_field(f_buf_u3d, field_t,type_real,3,llm)  ! 3D vel at cell centers
@@ -102,5 +103,5 @@
     INTEGER :: ind,i,j,ij,l
 
-    IF (omp_first) THEN
+    IF (is_omp_first_level) THEN
        DO ind=1,ndomain
           IF (.NOT. assigned_domain(ind)) CYCLE
@@ -128,5 +129,5 @@
     ENDIF
 
-!    !$OMP BARRIER
+    !$OMP BARRIER
   END SUBROUTINE caldyn_BC
    
@@ -143,4 +144,5 @@
     USE omp_para
     USE output_field_mod
+    USE checksum_mod
     IMPLICIT NONE
     LOGICAL,INTENT(IN)    :: write_out
@@ -291,8 +293,8 @@
     END SELECT
 
-!!$OMP BARRIER
+!$OMP BARRIER
     IF (write_out) THEN
 
-       IF (is_mpi_root) PRINT *,'CALL write_output_fields'
+       IF (is_master) PRINT *,'CALL write_output_fields'
 
 ! ---> for openMP test to fix later
@@ -450,17 +452,18 @@
 
 !!! Compute exner function and geopotential
-       DO l = 1,llm
+       IF (is_omp_level_master) THEN ! no openMP on vertical due to dependency
+         DO l = 1,llm
 !         !$OMP DO SCHEDULE(STATIC) 
           !DIR$ SIMD
-          DO ij=ij_begin_ext,ij_end_ext         
-             p_ik = ptop + mass_ak(l) + mass_bk(l)*ps(ij) ! FIXME : leave ps for the moment ; change ps to Ms later
-             !         p_ik = ptop + g*(mass_ak(l)+ mass_bk(l)*ps(i,j))
-             exner_ik = cpp * (p_ik/preff) ** kappa
-             pk(ij,l) = exner_ik
+            DO ij=ij_begin_ext,ij_end_ext         
+               p_ik = ptop + mass_ak(l) + mass_bk(l)*ps(ij) ! FIXME : leave ps for the moment ; change ps to Ms later
+               !         p_ik = ptop + g*(mass_ak(l)+ mass_bk(l)*ps(i,j))
+               exner_ik = cpp * (p_ik/preff) ** kappa
+               pk(ij,l) = exner_ik
              ! specific volume v = kappa*theta*pi/p = dphi/g/rhodz
-             geopot(ij,l+1) = geopot(ij,l) + (g*kappa)*rhodz(ij,l)*theta(ij,l)*exner_ik/p_ik
+               geopot(ij,l+1) = geopot(ij,l) + (g*kappa)*rhodz(ij,l)*theta(ij,l)*exner_ik/p_ik
           ENDDO
-       ENDDO
-
+         ENDDO
+       ENDIF
     ELSE 
        ! We are using a Lagrangian vertical coordinate
@@ -471,5 +474,6 @@
        IF(boussinesq) THEN ! compute only geopotential : pressure pk will be computed in compute_caldyn_horiz
           ! specific volume 1 = dphi/g/rhodz
-          DO l = 1,llm
+         IF (is_omp_level_master) THEN ! no openMP on vertical due to dependency
+           DO l = 1,llm
 !             !$OMP DO SCHEDULE(STATIC) 
              !DIR$ SIMD
@@ -477,40 +481,47 @@
                 geopot(ij,l+1) = geopot(ij,l) + g*rhodz(ij,l)
              ENDDO
-          ENDDO
+           ENDDO
+         ENDIF
        ELSE ! non-Boussinesq, compute geopotential and Exner pressure
           ! uppermost layer
-          !DIR$ SIMD
-          DO ij=ij_begin_ext,ij_end_ext         
-             pk(ij,llm) = ptop + (.5*g)*rhodz(ij,llm)
-          END DO
-          ! other layers
-          DO l = llm-1, 1, -1
-
-!          !$OMP DO SCHEDULE(STATIC) 
-             !DIR$ SIMD
-             DO ij=ij_begin_ext,ij_end_ext         
-                pk(ij,l) = pk(ij,l+1) + (.5*g)*(rhodz(ij,l)+rhodz(ij,l+1))
-             END DO
-          END DO
+         IF (is_omp_level_master) THEN  ! no openMP on vertical due to dependency
+
+           !DIR$ SIMD
+           DO ij=ij_begin_ext,ij_end_ext         
+              pk(ij,llm) = ptop + (.5*g)*rhodz(ij,llm)
+           END DO
+           ! other layers
+           DO l = llm-1, 1, -1
+
+!           !$OMP DO SCHEDULE(STATIC) 
+              !DIR$ SIMD
+              DO ij=ij_begin_ext,ij_end_ext         
+                 pk(ij,l) = pk(ij,l+1) + (.5*g)*(rhodz(ij,l)+rhodz(ij,l+1))
+              END DO
+           END DO
           ! surface pressure (for diagnostics)
-          DO ij=ij_begin_ext,ij_end_ext         
-             ps(ij) = pk(ij,1) + (.5*g)*rhodz(ij,1)
-          END DO
+           DO ij=ij_begin_ext,ij_end_ext         
+              ps(ij) = pk(ij,1) + (.5*g)*rhodz(ij,1)
+           END DO
 
           ! specific volume v = kappa*theta*pi/p = dphi/g/rhodz
-          DO l = 1,llm
+           DO l = 1,llm
 
 !             !$OMP DO SCHEDULE(STATIC) 
              !DIR$ SIMD
-             DO ij=ij_begin_ext,ij_end_ext         
-                p_ik = pk(ij,l)
-                exner_ik = cpp * (p_ik/preff) ** kappa
-                geopot(ij,l+1) = geopot(ij,l) + (g*kappa)*rhodz(ij,l)*theta(ij,l)*exner_ik/p_ik 
-                pk(ij,l) = exner_ik
-             ENDDO
-          ENDDO
+              DO ij=ij_begin_ext,ij_end_ext         
+                 p_ik = pk(ij,l)
+                 exner_ik = cpp * (p_ik/preff) ** kappa
+                 geopot(ij,l+1) = geopot(ij,l) + (g*kappa)*rhodz(ij,l)*theta(ij,l)*exner_ik/p_ik 
+                 pk(ij,l) = exner_ik
+              ENDDO
+            ENDDO
+          ENDIF
        END IF
 
     END IF
+
+!ym flush geopot
+!$OMP BARRIER
 
   CALL trace_end("compute_geopot")
@@ -799,21 +810,24 @@
   CALL trace_start("compute_caldyn_vert")
 
-!!$OMP BARRIER   
+!$OMP BARRIER   
 !!! cumulate mass flux convergence from top to bottom
-  DO  l = llm-1, 1, -1
+  IF (is_omp_level_master) THEN
+    DO  l = llm-1, 1, -1
 !    IF (caldyn_conserv==energy) CALL test_message(req_qu) 
 
 !!$OMP DO SCHEDULE(STATIC) 
 !DIR$ SIMD
-    DO ij=ij_begin,ij_end         
-        convm(ij,l) = convm(ij,l) + convm(ij,l+1)
+      DO ij=ij_begin,ij_end         
+          convm(ij,l) = convm(ij,l) + convm(ij,l+1)
+      ENDDO
     ENDDO
-  ENDDO
-
-! IMPLICIT FLUSH on convm
+  ENDIF
+
+!$OMP BARRIER
+! FLUSH on convm
 !!!!!!!!!!!!!!!!!!!!!!!!!
 
 ! compute dps
-  IF (omp_first) THEN
+  IF (is_omp_first_level) THEN
 !DIR$ SIMD
      DO ij=ij_begin,ij_end         
@@ -834,4 +848,7 @@
   ENDDO
 
+ !--> flush wflux  
+ !$OMP BARRIER
+
   DO l=ll_begin,ll_endm1
 !DIR$ SIMD
@@ -847,4 +864,5 @@
     ENDDO
   ENDDO
+
   
 ! Compute vertical transport
@@ -859,5 +877,5 @@
 
  !--> flush wwuu  
- ! !$OMP BARRIER
+ !$OMP BARRIER
 
 ! Add vertical transport to du
@@ -1018,8 +1036,11 @@
        ps = f_ps(ind)
        p  = f_p(ind)
+!$OMP BARRIER
        CALL compute_pression(ps,p,0)
        pk = f_pk(ind)
        pks = f_pks(ind)
+!$OMP BARRIER
        CALL compute_exner(ps,p,pks,pk,0)
+!$OMP BARRIER
        theta_rhodz = f_theta_rhodz(ind)
        theta = f_theta(ind)
Index: codes/icosagcm/trunk/src/check_conserve.f90
===================================================================
--- codes/icosagcm/trunk/src/check_conserve.f90	(revision 294)
+++ codes/icosagcm/trunk/src/check_conserve.f90	(revision 295)
@@ -9,10 +9,6 @@
    
   PUBLIC init_check_conserve, check_conserve 
-    REAL(rstd),SAVE:: mtot0,ztot0,etot0,ang0,stot0,rmsv0
-!$OMP THREADPRIVATE(mtot0,ztot0,etot0,ang0,stot0,rmsv0)
-    REAL(rstd),SAVE:: etot,ang,stot,rmsv
-!$OMP THREADPRIVATE(etot,ang,stot,rmsv)
-    REAL(rstd),SAVE:: ztot
-!$OMP THREADPRIVATE(ztot)	
+    REAL(rstd),SAVE:: mtot0,ztot0,etot0,angtot0,stot0,rmsvtot0
+!$OMP THREADPRIVATE(mtot0,ztot0,etot0,angtot0,stot0,rmsvtot0)
      
 CONTAINS 
@@ -36,5 +32,6 @@
   USE caldyn_gcm_mod
   USE exner_mod 
-  USE mpipara, ONLY : is_mpi_root, comm_icosa
+  USE mpipara, ONLY : is_mpi_master, comm_icosa
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -48,8 +45,7 @@
     INTEGER::ind,ierr
     REAL(rstd) :: mtot, rmsdpdt
-
-    etot=0.0; ang=0.0;stot=0.0;rmsv=0.0 
-    ztot = 0.0 
-
+    REAL(rstd) :: etot, stot, angtot, rmsvtot, ztot
+
+    CALL transfert_request(f_ue,req_e1_vect)
     CALL pression(f_ps,f_p)
 
@@ -65,34 +61,33 @@
     CALL vorticity(f_ue,f_vort)
     CALL check_mass_conserve(f_ps,f_dps,mtot,rmsdpdt)
-    CALL check_PV 
+    CALL check_PV(ztot) 
     CALL exner(f_ps,f_p,f_pks,f_pk)
-    CALL check_EN(f_ue,f_theta_rhodz,f_phis) 
-
-    IF (is_mpi_root) THEN 
-!$OMP MASTER       
-       IF ( it == itau0  ) Then 
+    CALL check_EN(f_ue,f_theta_rhodz,f_phis, etot, stot, angtot, rmsvtot) 
+
+    IF (is_master) THEN 
+       IF ( it == itau0  ) THEN 
           ztot0 = ztot
           mtot0 = mtot
           etot0 = etot 
-          ang0  = ang 
+          angtot0  = angtot 
           stot0 = stot 
        END IF
 
-       rmsv=SQRT(rmsv/mtot) 
+       rmsvtot=SQRT(rmsvtot/mtot) 
        ztot=ztot/ztot0-1. ; mtot=mtot/mtot0-1. 
-       etot=etot/etot0-1. ; ang=ang/ang0-1. ; stot=stot/stot0-1. 
+       etot=etot/etot0-1. ; angtot=angtot/angtot0-1. ; stot=stot/stot0-1. 
        rmsdpdt= daysec*1.e-2*sqrt(rmsdpdt/ncell_glo)  
        
        OPEN(134,file="checkconsicosa.txt",position='append')
-       WRITE(134,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
-       WRITE(134,*)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang 
+       WRITE(134,4000)mtot,rmsdpdt,etot,ztot,stot,rmsvtot,angtot
+       WRITE(134,*)mtot,rmsdpdt,etot,ztot,stot,rmsvtot,angtot 
        WRITE(134,*)"=================================================="
-       WRITE(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsv,ang
+       WRITE(*,4000)mtot,rmsdpdt,etot,ztot,stot,rmsvtot,angtot
        
 4000   FORMAT(10x,'masse',5x,'rmsdpdt',5x,'energie',5x,'enstrophie'  &
             ,5x,'entropie',5x,'rmsv',5x,'mt.ang',/,'GLOB  '                &
-            ,e10.3,e13.6,5e10.3/)     
+            ,e10.3,e13.6,5e13.3/)     
        close(134)
-!$OMP END MASTER 
+      
     END IF
   END SUBROUTINE check_conserve
@@ -105,4 +100,5 @@
   USE transfert_omp_mod
   USE icosa
+  USE omp_para
   IMPLICIT NONE
     TYPE(t_field),POINTER :: f_ps(:)
@@ -117,5 +113,5 @@
     mloc=0.0; rmsloc=0.0
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
+      IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -141,5 +137,6 @@
 !$OMP END MASTER
     ELSE
-      
+      mtot=mloc
+      rmsdpdt=rmsloc
     ENDIF
     
@@ -148,12 +145,16 @@
 !---------------------------------------------------------------------
 
-  SUBROUTINE check_en(f_ue,f_theta_rhodz,f_phis) 
+  SUBROUTINE check_en(f_ue,f_theta_rhodz,f_phis, etot, stot, angtot, rmsvtot)  
   USE icosa
   USE pression_mod
   USE vorticity_mod
+  USE mpi_mod
+  USE mpipara
+  USE transfert_omp_mod
   IMPLICIT NONE
     TYPE(t_field), POINTER :: f_ue(:)
     TYPE(t_field), POINTER :: f_theta_rhodz(:)
     TYPE(t_field), POINTER :: f_phis(:)
+    REAL(rstd),INTENT(OUT) :: etot, stot, angtot, rmsvtot
     REAL(rstd), POINTER :: ue(:,:)
     REAL(rstd), POINTER :: p(:,:) 
@@ -162,6 +163,9 @@
     REAL(rstd), POINTER :: phis(:) 
     REAL(rstd), POINTER :: rhodz(:,:) 
+    REAL(rstd) :: e, s, ang, rmsv
+    REAL(rstd) :: e_mpi, s_mpi, ang_mpi, rmsv_mpi
     INTEGER :: ind
 
+    e = 0 ; s = 0 ; ang = 0 ; rmsv = 0
 
     DO ind=1,ndomain 
@@ -175,13 +179,32 @@
       pk=f_pk(ind) 
       phis=f_phis(ind) 
-      CALL compute_en(ind,ue,p,rhodz,theta_rhodz,pk,phis)
+      CALL compute_en(ind,ue,p,rhodz,theta_rhodz,pk,phis, e, s, ang, rmsv)
     END DO 
- 
+
+    IF (using_mpi) THEN
+      CALL reduce_sum_omp(e, e_mpi)
+      CALL reduce_sum_omp(s, s_mpi)
+      CALL reduce_sum_omp(ang, ang_mpi)
+      CALL reduce_sum_omp(rmsv, rmsv_mpi)
+!$OMP MASTER    
+      CALL MPI_REDUCE(e_mpi, etot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+      CALL MPI_REDUCE(s_mpi, stot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+      CALL MPI_REDUCE(ang_mpi, angtot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+      CALL MPI_REDUCE(rmsv_mpi, rmsvtot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+!$OMP END MASTER
+    ELSE
+      etot=e
+      stot=s
+      angtot=ang
+      rmsvtot=rmsv
+    ENDIF 
+
   END SUBROUTINE check_en 
 
-  SUBROUTINE compute_en(ind,u,p,rhodz,theta_rhodz,pk,phis)
+  SUBROUTINE compute_en(ind,u,p,rhodz,theta_rhodz,pk,phis, e, s, ang, rmsv)
   USE icosa
   USE disvert_mod
   USE wind_mod
+  USE omp_para
   IMPLICIT NONE
     INTEGER,INTENT(IN)::ind 
@@ -192,4 +215,9 @@
     REAL(rstd),INTENT(IN) :: pk(iim*jjm,llm)
     REAL(rstd),INTENT(IN) :: phis(iim*jjm)
+    REAL(rstd),INTENT(INOUT) :: e
+    REAL(rstd),INTENT(INOUT) :: s
+    REAL(rstd),INTENT(INOUT) :: ang
+    REAL(rstd),INTENT(INOUT) :: rmsv
+    
     REAL(rstd):: theta(iim*jjm,llm)
     REAL(rstd)::KE(iim*jjm,llm) 
@@ -204,5 +232,5 @@
 
   
-    DO l = 1, llm
+    DO l = ll_begin, ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -211,5 +239,5 @@
           theta(ij,l) = theta_rhodz(ij,l)/rhodz(ij,l)
           IF (domain(ind)%own(i,j)) THEN
-	    stot = stot + Ai(ij)*theta_rhodz(ij,l)
+	    s = s + Ai(ij)*theta_rhodz(ij,l)
           END IF 
         END DO 
@@ -217,5 +245,5 @@
     END DO 
 
-    DO l = 1, llm
+    DO l = ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -234,10 +262,10 @@
     END DO  
 
-    DO l = 1, llm
+    DO l = ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
 	  ij=(j-1)*iim+i
           IF (domain(ind)%own(i,j)) THEN
-	    etot = etot + masse(ij,l)*(phis(ij)+theta(ij,l)*pk(ij,l)+KE(ij,l))
+	    e = e + masse(ij,l)*(phis(ij)+theta(ij,l)*pk(ij,l)+KE(ij,l))
           END IF 
         END DO 
@@ -251,5 +279,5 @@
     radomeg = rad*omega
 
-    DO l = 1, llm
+    DO l = ll_begin,ll_end
       DO j=jj_begin,jj_end
         DO i=ii_begin,ii_end
@@ -267,11 +295,17 @@
 !---------------------------------------------------------------------
 
-  SUBROUTINE check_PV 
-  USE icosa
-  IMPLICIT NONE
+  SUBROUTINE check_PV(ztot)
+  USE icosa
+  USE mpi_mod
+  USE mpipara
+  USE transfert_omp_mod
+  IMPLICIT NONE
+     REAL(rstd),INTENT(OUT) :: ztot
      REAL(rstd), POINTER :: vort(:,:)
      REAL(rstd), POINTER :: rhodz(:,:) 
      INTEGER :: ind
-
+     REAL(rstd) :: z,z_mpi
+
+     z=0
      DO ind=1,ndomain 
        IF (.NOT. assigned_domain(ind)) CYCLE
@@ -280,15 +314,26 @@
        vort=f_vort(ind)
        rhodz=f_rhodz(ind) 
-       CALL compute_PV(vort,rhodz) 
+       CALL compute_PV(vort,rhodz,z) 
      ENDDO
+
+    IF (using_mpi) THEN
+      CALL reduce_sum_omp(z, z_mpi)
+!$OMP MASTER    
+      CALL MPI_REDUCE(z_mpi, ztot, 1, MPI_REAL8, MPI_SUM, 0, comm_icosa, ierr)
+!$OMP END MASTER
+    ELSE
+      ztot=z
+    ENDIF 
  
   END SUBROUTINE check_PV 
 
-  SUBROUTINE compute_PV(vort,rhodz) 
+  SUBROUTINE compute_PV(vort,rhodz,z) 
   USE icosa
   USE disvert_mod
+  USE omp_para
   IMPLICIT NONE 
     REAL(rstd),INTENT(IN) :: vort(2*iim*jjm,llm)
     REAL(rstd),INTENT(IN) :: rhodz(iim*jjm,llm) 
+    REAL(rstd),INTENT(INOUT) :: z
     REAL(rstd)::qv1,qv2 
     REAL(rstd)::hv1,hv2  
@@ -297,5 +342,5 @@
     hv1 = 0.0 ; hv2 = 0.0 
    
-    DO l = 1,llm
+    DO l = ll_begin,ll_end
       DO j=jj_begin+1,jj_end-1
         DO i=ii_begin+1,ii_end-1
@@ -313,8 +358,9 @@
           qv2 =( vort(ij+z_down,l)+fv(ij+z_down) )/hv2
 
-          ztot = ztot + (qv1*qv1*hv1 + qv2*qv2*hv2) 
+          z = z + (qv1*qv1*hv1 + qv2*qv2*hv2) 
 
         ENDDO
       ENDDO
+      
     ENDDO
 
Index: codes/icosagcm/trunk/src/checksum.f90
===================================================================
--- codes/icosagcm/trunk/src/checksum.f90	(revision 295)
+++ codes/icosagcm/trunk/src/checksum.f90	(revision 295)
@@ -0,0 +1,66 @@
+MODULE checksum_mod
+
+
+! simple function to perform checksum on T field
+! works only on 1 process
+! usefull to check openMP synchronisation problem
+! need to be enhanced...
+
+CONTAINS
+
+  SUBROUTINE checksum(field)
+  USE icosa
+  IMPLICIT NONE
+    TYPE(t_field), POINTER :: field(:)
+    INTEGER :: intval(2)
+    INTEGER :: ind,i,j,ij,l
+    INTEGER :: tot_sum
+        
+
+!$OMP BARRIER
+!$OMP MASTER
+    tot_sum=0
+    DO ind=1,ndomain
+      CALL swap_dimensions(ind)
+      CALL swap_geometry(ind)
+       
+      IF (field(ind)%ndim==2) THEN
+        DO j=jj_begin,jj_end
+           DO i=ii_begin,ii_end
+              ij=(j-1)*iim+i
+              IF (domain(ind)%own(i,j)) THEN
+                intval=transfer(field(ind)%rval2d(ij),intval,2)  
+                tot_sum=tot_sum+intval(1)+intval(2)
+              ENDIF
+           ENDDO
+        ENDDO
+   
+      ELSE IF (field(ind)%ndim==3) THEN
+        
+        DO l=1,size(field(ind)%rval3d,2)
+          DO j=jj_begin,jj_end
+             DO i=ii_begin,ii_end
+                ij=(j-1)*iim+i
+                IF (domain(ind)%own(i,j)) THEN
+                  intval=transfer(field(ind)%rval3d(ij,l),intval,2)  
+                  tot_sum=tot_sum+intval(1)+intval(2)
+                ENDIF
+             ENDDO
+          ENDDO
+        ENDDO
+     
+      ENDIF
+    ENDDO
+!$OMP END MASTER
+!$OMP BARRIER    
+    
+!$OMP MASTER
+    PRINT*,"CheckSum Field",field(1)%name,tot_sum
+!$OMP END MASTER
+  
+  
+  
+  END SUBROUTINE checksum
+  
+END MODULE checksum_mod
+  
Index: codes/icosagcm/trunk/src/dissip_gcm.f90
===================================================================
--- codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 294)
+++ codes/icosagcm/trunk/src/dissip_gcm.f90	(revision 295)
@@ -71,4 +71,5 @@
   USE time_mod
   USE transfert_omp_mod
+  USE omp_para
   IMPLICIT NONE
   
@@ -100,15 +101,15 @@
    CASE('none')
       rayleigh_friction_type=0
-      IF (is_mpi_root) PRINT *, 'No Rayleigh friction'
+      IF (is_master) PRINT *, 'No Rayleigh friction'
    CASE('dcmip2_schaer_noshear')
       rayleigh_friction_type=1
       rayleigh_shear=0
-      IF (is_mpi_root) PRINT *, 'Rayleigh friction : Schaer-like mountain without shear DCMIP2.1'
+      IF (is_master) PRINT *, 'Rayleigh friction : Schaer-like mountain without shear DCMIP2.1'
    CASE('dcmip2_schaer_shear')
       rayleigh_shear=1
       rayleigh_friction_type=2
-      IF (is_mpi_root) PRINT *, 'Rayleigh friction : Schaer-like mountain with shear DCMIP2.2'
+      IF (is_master) PRINT *, 'Rayleigh friction : Schaer-like mountain with shear DCMIP2.2'
    CASE DEFAULT
-      IF (is_mpi_root) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), ' in dissip_gcm.f90/init_dissip'
+      IF (is_master) PRINT *, 'Bad selector : rayleigh_friction_type =', TRIM(rayleigh_friction_key), ' in dissip_gcm.f90/init_dissip'
       STOP
    END SELECT
@@ -119,5 +120,5 @@
       rayleigh_tau = rayleigh_tau / scale_factor
       IF(rayleigh_tau<=0) THEN
-         IF (is_mpi_root) PRINT *, 'Forbidden : negative value for rayleigh_friction_tau =',rayleigh_tau
+         IF (is_master) PRINT *, 'Forbidden : negative value for rayleigh_friction_tau =',rayleigh_tau
          STOP
       END IF
@@ -156,7 +157,8 @@
     cdivgrad=-1
     cgradrot=-1
-    
+
+!$OMP BARRIER
+!$OMP MASTER
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -175,6 +177,6 @@
       ENDDO        
     ENDDO
-  
-
+!$OMP END MASTER  
+!$OMP BARRIER
 
     DO it=1,20
@@ -184,5 +186,5 @@
         CALL transfert_request(f_u,req_e1_vect)
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -197,5 +199,5 @@
       
       DO ind=1,ndomain
-        IF (.NOT. assigned_domain(ind)) CYCLE
+        IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -214,5 +216,5 @@
 
       IF (using_mpi) THEN 
-        CALL reduce_sum_omp(dumax,dumax1)
+        CALL reduce_max_omp(dumax,dumax1)
 !$OMP MASTER        
         CALL MPI_ALLREDUCE(dumax1,dumax,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
@@ -220,10 +222,10 @@
         CALL bcast_omp(dumax)  
       ELSE
-        CALL allreduce_sum_omp(dumax,dumax1)
+        CALL allreduce_max_omp(dumax,dumax1)
         dumax=dumax1
       ENDIF  
 			
       DO ind=1,ndomain
-        IF (.NOT. assigned_domain(ind)) CYCLE
+        IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -232,18 +234,19 @@
         u=du/dumax
       ENDDO
-      IF (is_mpi_root) PRINT *,"gradiv : it :",it ,": dumax",dumax
+      IF (is_master) PRINT *,"gradiv : it :",it ,": dumax",dumax
 
     ENDDO 
-    IF (is_mpi_root) PRINT *,"gradiv : dumax",dumax
-    IF (is_mpi_root) PRINT *, 'mean T-cell edge size (km)', 1.45*radius/iim_glo/1000., &
+    IF (is_master) PRINT *,"gradiv : dumax",dumax
+    IF (is_master) PRINT *, 'mean T-cell edge size (km)', 1.45*radius/iim_glo/1000., &
                               'effective T-cell half-edge size (km)', dumax**(-.5/nitergdiv)/1000
-    IF (is_mpi_root)  PRINT *, 'Max. time step assuming c=340 m/s and Courant number=2.8 :', &
+    IF (is_master)  PRINT *, 'Max. time step assuming c=340 m/s and Courant number=2.8 :', &
                                2.8/340.*dumax**(-.5/nitergdiv)
 
     cgraddiv=dumax**(-1./nitergdiv)
-    IF (is_mpi_root) PRINT *,"cgraddiv : ",cgraddiv
-
+    IF (is_master) PRINT *,"cgraddiv : ",cgraddiv
+
+!$OMP BARRIER
+!$OMP MASTER
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -262,4 +265,6 @@
       ENDDO        
     ENDDO
+!$OMP END MASTER  
+!$OMP BARRIER
 
 
@@ -270,5 +275,5 @@
         CALL transfert_request(f_u,req_e1_vect)
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -283,5 +288,5 @@
       
       DO ind=1,ndomain
-        IF (.NOT. assigned_domain(ind)) CYCLE
+        IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -300,5 +305,5 @@
 
       IF (using_mpi) THEN 
-        CALL reduce_sum_omp(dumax,dumax1)
+        CALL reduce_max_omp(dumax,dumax1)
 !$OMP MASTER        
         CALL MPI_ALLREDUCE(dumax1,dumax,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
@@ -306,5 +311,5 @@
         CALL bcast_omp(dumax)  
       ELSE
-        CALL allreduce_sum_omp(dumax,dumax1)
+        CALL allreduce_max_omp(dumax,dumax1)
         dumax=dumax1
       ENDIF  
@@ -312,5 +317,5 @@
       
       DO ind=1,ndomain
-        IF (.NOT. assigned_domain(ind)) CYCLE
+        IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -320,16 +325,17 @@
       ENDDO
       
-      IF (is_mpi_root) PRINT *,"gradrot : it :",it ,": dumax",dumax
+      IF (is_master) PRINT *,"gradrot : it :",it ,": dumax",dumax
 
     ENDDO 
-    IF (is_mpi_root) PRINT *,"gradrot : dumax",dumax
+    IF (is_master) PRINT *,"gradrot : dumax",dumax
   
     cgradrot=dumax**(-1./nitergrot) 
-    IF (is_mpi_root) PRINT *,"cgradrot : ",cgradrot
+    IF (is_master) PRINT *,"cgradrot : ",cgradrot
    
 
 
+!$OMP BARRIER
+!$OMP MASTER
     DO ind=1,ndomain
-      IF (.NOT. assigned_domain(ind)) CYCLE
       CALL swap_dimensions(ind)
       CALL swap_geometry(ind)
@@ -344,4 +350,6 @@
       ENDDO  
     ENDDO
+!$OMP END MASTER
+!$OMP BARRIER
 
     DO it=1,20
@@ -351,5 +359,5 @@
         CALL transfert_request(f_theta,req_i1)
         DO ind=1,ndomain
-          IF (.NOT. assigned_domain(ind)) CYCLE
+          IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
           CALL swap_dimensions(ind)
           CALL swap_geometry(ind)
@@ -364,5 +372,5 @@
       
       DO ind=1,ndomain
-        IF (.NOT. assigned_domain(ind)) CYCLE
+        IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -379,5 +387,5 @@
 
       IF (using_mpi) THEN 
-        CALL reduce_sum_omp(dthetamax ,dthetamax1)
+        CALL reduce_max_omp(dthetamax ,dthetamax1)
 !$OMP MASTER        
         CALL MPI_ALLREDUCE(dthetamax1,dthetamax,1,MPI_REAL8,MPI_MAX,comm_icosa,ierr)
@@ -385,12 +393,12 @@
         CALL bcast_omp(dthetamax)  
       ELSE
-        CALL allreduce_sum_omp(dthetamax,dthetamax1)
+        CALL allreduce_max_omp(dthetamax,dthetamax1)
         dumax=dumax1
       ENDIF  
       
-      IF (is_mpi_root) PRINT *,"divgrad : it :",it ,": dthetamax",dthetamax
+      IF (is_master) PRINT *,"divgrad : it :",it ,": dthetamax",dthetamax
 
       DO ind=1,ndomain
-        IF (.NOT. assigned_domain(ind)) CYCLE
+        IF (.NOT. assigned_domain(ind) .OR. .NOT. is_omp_level_master) CYCLE
         CALL swap_dimensions(ind)
         CALL swap_geometry(ind)
@@ -401,8 +409,8 @@
     ENDDO 
 
-    IF (is_mpi_root) PRINT *,"divgrad : divgrad",dthetamax
+    IF (is_master) PRINT *,"divgrad : divgrad",dthetamax
   
     cdivgrad=dthetamax**(-1./niterdivgrad) 
-    IF (is_mpi_root) PRINT *,"cdivgrad : ",cdivgrad
+    IF (is_master) PRINT *,"cdivgrad : ",cdivgrad
 
      
@@ -431,9 +439,9 @@
        dtdissip=itau_dissip*dt
     ELSE
-       IF (is_mpi_root) PRINT *,"No dissipation time set, setting itau_dissip to 1000000000"
+       IF (is_master) PRINT *,"No dissipation time set, setting itau_dissip to 1000000000"
        itau_dissip=100000000
     END IF
     itau_dissip=MAX(1,itau_dissip)
-    IF (is_mpi_root) PRINT *,"mintau ",mintau,"itau_dissip",itau_dissip," dtdissip ",dtdissip
+    IF (is_master) PRINT *,"mintau ",mintau,"itau_dissip",itau_dissip," dtdissip ",dtdissip
 
   END SUBROUTINE init_dissip 
@@ -713,5 +721,5 @@
 
     CALL trace_start("divgrad")
-       
+
     DO ind=1,ndomain
       IF (.NOT. assigned_domain(ind)) CYCLE
Index: codes/icosagcm/trunk/src/domain.f90
===================================================================
--- codes/icosagcm/trunk/src/domain.f90	(revision 294)
+++ codes/icosagcm/trunk/src/domain.f90	(revision 295)
@@ -449,11 +449,11 @@
     
     ind=0
-    DO rank=0,omp_size-1
-      nb_domain=ndomain/omp_size
-      IF ( rank < MOD(ndomain,omp_size) ) nb_domain=nb_domain+1
+    DO rank=0,omp_domain_size-1
+      nb_domain=ndomain/omp_domain_size
+      IF ( rank < MOD(ndomain,omp_domain_size) ) nb_domain=nb_domain+1
     
       DO i=1,nb_domain
        ind=ind+1
-       IF (rank==omp_rank) THEN 
+       IF (rank==omp_domain_rank) THEN 
          assigned_domain(ind)=.TRUE.
          PRINT *,"Rank ",mpi_rank," task ",rank," local domain : ",ind," global domain ",domloc_glo_ind(ind)
